<?php

    class Ragtek_PC_ControllerPublic_Page extends
        XFCP_Ragtek_PC_ControllerPublic_Page
    {

        public function actionIndex()
        {

            if ($this->_request->isPost())
            {
                $this->_assertPostOnly();
                $nodeName = $this->_input->filterSingle('node_name', XenForo_Input::STRING);
                $page = $this->_getPageOrError($nodeName);

                $this->assertNotFlooding(Ragtek_PC_StaticMethods::CONTENT_TYPE);

                // guests not allowed
                $this->_assertRegistrationRequired();

                // the user is the current visitor
                $userId = XenForo_Visitor::getUserId();

                $message = $this->getHelper('Editor')->getMessageText('message', $this->_input);
                $message = XenForo_Helper_String::autoLinkBbCode($message);

                $this->_getCommentModel()->insertComment(array(
                                                              'user_id' => $userId,
                                                              'message' => $message,
                                                              'node_id' => $page['node_id']
                                                         ));

                $lastDate = $this->_input->filterSingle('last_date', XenForo_Input::UINT);

                $comments = $this->_getCommentModel()->getNewestCommentsByDate($page['node_id'], $lastDate);
                foreach ($comments AS &$comment)
                {
                    // TODO remove this later
                    $comment['position'] = $this->_getCommentModel()->getCommentBeforeOnPage($comment);
                }
                if (count($comments) > 4) {
                    $firstUnshownPost = $this->getModelFromCache('Ragtek_PC_Model_Pagecomment')->getNextCommentInPage($page['node_id'], $lastDate);
                    // remove the extra post
                    array_pop($comments);
                }
                else
                {
                    $firstUnshownPost = false;
                }

                $comments = array_reverse($comments, true);


                $viewParams = array(
                    'firstUnshownPost' => $firstUnshownPost,
                    'page' => $page,
                    'notes' => $comments,
                    'lastMessage' => end($comments)
                );

                return $this->responseView(
                    'Ragtek_PC_View_ViewNewComments',
                    'ragtek_page_new_comments',
                    $viewParams
                );

            }
            /** @var $return XenForo_ControllerResponse_View */
            $return = parent::actionIndex();

            if ($return->params['page']['ragtek_allow_comments'] == 1){

                $nodeId = $return->params['page']['node_id'];


                $page = max(1, $this->_input->filterSingle('page', XenForo_Input::UINT));

                $postsPerPage = Ragtek_PC_StaticMethods::perPage();

                $comments = $this->_getComments($nodeId, $page, $postsPerPage);

                $totalComments = $this->getModelFromCache('Ragtek_PC_Model_Pagecomment')->countCommentsForPage($nodeId);

                $return->params['page']['ragtek_comments'] = $comments;

                $lastDate = end($comments);

                $return->params += array(
                    'lastMessageDate' => $lastDate['post_date'],
                    'pagepage' => $page,
                    'postsPerPage' => $postsPerPage,
                    'totalPosts' => $totalComments,
                    'messagetamplate' => 'message'
                );
            }

            return $return;
        }


        protected function _getComments($nodeId = NULL, $page = 1, $postsPerPage)
        {
            $fetch = array(
                'perPage' => $postsPerPage,
                'page' => $page,
                'join' => Ragtek_PC_Model_Pagecomment::FETCH_USER |
                          Ragtek_PC_Model_Pagecomment::FETCH_AVATAR |
                          Ragtek_PC_Model_Pagecomment::FETCH_NODE
            );

            $comments = $this->_getCommentModel()->getCommentsByPageId($nodeId, $fetch);
            return $comments;
        }

        /**
         * @return Ragtek_PC_Model_Pagecomment
         */
        protected function _getCommentModel()
        {
            return $this->getModelFromCache('Ragtek_PC_Model_Pagecomment');
        }

        protected function _canonicalizeRequestUrl(array $pageassd)
        {
            return true;
            $pageNr = max(1, $this->_input->filterSingle('page', XenForo_Input::UINT));

            $postsPerPage = Ragtek_PC_StaticMethods::perPage();

            $nodeName = $this->_input->filterSingle('node_name', XenForo_Input::STRING);
            $page = $this->_getPageOrError($nodeName);

            $totalComments = $this->getModelFromCache('Ragtek_PC_Model_Pagecomment')->countCommentsForPage($page['node_id']);

            $this->canonicalizePageNumber($pageNr, $postsPerPage, $totalComments + 1, 'pages', $page);

            $this->canonicalizeRequestUrl(
                XenForo_Link::buildPublicLink('pages', $page, array('page' => $pageNr))
            );
        }
    }
 
