<?php

    class Ragtek_PC_DW_Page extends
        XFCP_Ragtek_PC_DW_Page
    {


        protected function _getFields()
        {
            $array = parent::_getFields();

            $array['xf_page']['ragtek_allow_comments'] = array('type' => self::TYPE_BOOLEAN, 'default' => 0);
            $array['xf_page']['ragtek_link_in_navbar'] = array('type' => self::TYPE_BOOLEAN, 'default' => 0);

            return $array;
        }


        /**
         * delete all Comments
         */
        protected function _preDelete()
        {
            parent::_preDelete();
            $nodeId = $this->get('node_id');
            $comments = $this->getModelFromCache('Ragtek_PC_Model_Pagecomment')->getCommentsByPageId($nodeId);

            foreach ($comments AS $comment) {
                $dw = XenForo_DataWriter::create('Ragtek_PC_DW_Comments');
                $dw->setExistingData($comment);
                $dw->delete();
            }
        }


        protected function _postSave()
        {
            parent::_postSave();
            XenForo_Application::set('last_inserter_page', $this->getMergedData());
            $this->_rebuildNavbarCache();
        }

        protected function _postDelete()
        {
            parent::_postDelete();
            $this->_rebuildNavbarCache();
        }

        protected function _rebuildNavbarCache()
        {
            /** @var $model Ragtek_PC_Model_Router */
            $model = XenForo_Model::create('Ragtek_PC_Model_Router');
            $model->rebuildTabsCache();
        }
    }
 
