<?php

class Ragtek_PC_Helper
{

    const DEL_TYPE_ONLY_SOFT = 1;
    const DEL_TYPE_ONLY_HARD = 2;
    const DEL_TYPE_HARD_AND_SOFT = 3;


    public static function getViewFormParams($target, $title = '', $delType = self::DEL_TYPE_ONLY_HARD, $text = '')
    {
        $params = array(
            'title'      => $title,
            'formTarget' => $target,
            'text'       => $text,
            'delType'    => $delType
        );

        return $params;
    }

    public static function getAllNodesByType($type = 'Page', $ignoreNestedSetOrdering = false, $listView = false)
    {
        /** @var $nodeModel XenForo_Model_Node */
        $nodeModel = self::getNodeModel();

        $nodes = $nodeModel->getAllNodes($ignoreNestedSetOrdering, $listView);
        foreach ($nodes AS $node) {
            if ($node['node_type_id'] != $type) {
                unset($nodes[$node['node_id']]);
            }
        }

        return $nodes;
    }


    /**
     * @static
     * @return XenForo_Model_Node
     */
    protected static function getNodeModel()
    {
        return XenForo_Model::create('XenForo_Model_Node');
    }
}