<?php

    class Ragtek_PC_Install
    {

        public function _installVersion16()
        {


            // ADD ALERT & newsfeed HANDLER
            $query['alerthandler'] = "
        INSERT INTO xf_content_type_field
        (
            content_type ,            field_name ,            field_value
        )
        VALUES
        (
            '" . Ragtek_PC_StaticMethods::CONTENT_TYPE . "',
            'alert_handler_class',
            'Ragtek_PC_AlertHandler_Comment'
        ),
        (
        '" . Ragtek_PC_StaticMethods::CONTENT_TYPE . "',
            'news_feed_handler_class',
            'Ragtek_PC_NewsFeedHandler_Comment'
        )
        ";

            if (!self::checkIfExist('ragtek_pagecomments', 'ip_id')) {
                self::addColumn('ragtek_pagecomments', 'ip_id', 'INT UNSIGNED NOT NULL');
            }


            $this->_runQuery($query);
            self::_end();
        }

        public function _installVersion13()
        {
            /** @var $model Ragtek_PC_Model_Router */
            $model = XenForo_Model::create('Ragtek_PC_Model_Router');
            $model->rebuildTabsCache();
        }

        public function _installVersion9()
        {

            if (!self::checkIfExist('xf_page', 'ragtek_link_in_navbar')) {
                $query['add_page_navbar'] = "
            ALTER TABLE `xf_page` ADD `ragtek_link_in_navbar` TINYINT( 3 ) NOT NULL DEFAULT '0'
        ";
            }

            // remove the unnecessary table
            // we could also remove it from installVersion1 but i think this is better for all "beta testers"
            $query['drop_routes'] = "DROP TABLE  ragtek_alternative_page_routes";
            $this->_runQuery($query);
        }


        public function _installVersion1()
        {

            if (!self::checkIfExist('xf_page', 'ragtek_allow_comments')) {
                $queries['add_page_comments'] = "
            ALTER TABLE `xf_page` ADD `ragtek_allow_comments` TINYINT( 3 ) UNSIGNED NOT NULL DEFAULT '0'
        ";
            }
            $queries['add_page_column_table'] = "
            CREATE TABLE IF NOT EXISTS `ragtek_pagecomments` (
              `comment_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
              `node_id` int(10) unsigned NOT NULL,
              `user_id` int(10) unsigned NOT NULL,
              `post_date` int(10) unsigned NOT NULL,
              `message` mediumtext NOT NULL,
              PRIMARY KEY (`comment_id`),
              KEY `node_id` (`node_id`)
            ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 ;
        ";

            $queries['add_route_table'] = "
        CREATE TABLE IF NOT EXISTS `ragtek_alternative_page_routes` (
          `title` varchar(50) NOT NULL,
          `section` varchar(50) NOT NULL,
          UNIQUE KEY `unique` (`title`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
        ";

// QUICK AND DIRTY BUGFIX
            $db = XenForo_Application::getDb();
           $db->query("
                       DELETE FROM xf_content_type_field
                       WHERE   content_type = '" . Ragtek_PC_StaticMethods::CONTENT_TYPE . "'
                   ");


            $db->query( "
                       DELETE FROM xf_content_type WHERE content_type = '" . Ragtek_PC_StaticMethods::CONTENT_TYPE ."'");

// fix end

            $queries['content_type'] = "
        INSERT INTO xf_content_type (
            content_type ,
           addon_id ,
           fields
            )
        VALUES (
            '" . Ragtek_PC_StaticMethods::CONTENT_TYPE . "', '" . Ragtek_PC_StaticMethods::ADDON_ID . "', ''
        );
        ";

            $queries['content_type_field'] = "
        INSERT INTO xf_content_type_field
        (
            content_type ,            field_name ,            field_value
        )
        VALUES
        (
            '" . Ragtek_PC_StaticMethods::CONTENT_TYPE . "',
            'search_handler_class',
             'Ragtek_PC_Search_DataHandler_Comment'
    	)
    	";

            $this->_runQuery($queries);
        }


        /**
         *
         * @param array     Current version of the installed add-on (if installed)
         * @param array     Version of the add-on which will be released
         *
         */
        public static function install($existingAddOn, $addOnData)
        {
            $startVersionId = 1;
            $endVersionId = $addOnData['version_id'];

            if ($existingAddOn) {
                $startVersionId = $existingAddOn['version_id'] + 1;
            }
            $install = self::getInstance();

            for ($i = $startVersionId; $i <= $endVersionId; $i++)
            {
                $method = '_installVersion' . $i;
                if (method_exists($install, $method) === false) {
                    continue;
                }
                $install->$method();
            }
        }

        public static function _runQuery(array $queries)
        {
            /** @var $db XenForo_Db */
            $db = XenForo_Application::get('db');       // todo refactor
            XenForo_Db::beginTransaction($db);

            foreach ($queries AS $id => $query) {
                $db->query($query);
            }
            XenForo_Db::commit($db);
        }


        static private $instance = null;

        public static function getInstance()
        {

            if (self::$instance == null) {
                self::$instance = new self();
            }
            return self::$instance;
        }

        public static function _end()
        {
            XenForo_Model::create('XenForo_Model_ContentType')->rebuildContentTypeCache();
        }


        public static function uninstall()
        {
            $queries = array();
            $queries['drop_category'] = "
             DROP TABLE ragtek_pagecomments;
        ";

            $queries['delete_fields'] = "
            DELETE FROM xf_content_type_field
            WHERE   content_type = '" . Ragtek_PC_StaticMethods::CONTENT_TYPE . "'
        ";


            $queries[] = "
            DELETE FROM xf_content_type WHERE content_type = '" . Ragtek_PC_StaticMethods::CONTENT_TYPE ."'";

            $queries[] = "ALTER TABLE `xf_page` DROP ragtek_allow_comments";
            $queries[] = "ALTER TABLE `xf_page` DROP ragtek_link_in_navbar";

            self::_runQuery($queries);
            self::_end();
        }


        public static function addColumn($table, $field, $attr)
        {
            if (!self::checkIfExist($table, $field)) {
                $db = XenForo_Application::get('db');
                return $db->query("ALTER TABLE `" . $table . "` ADD `" . $field . "` " . $attr);
            }
        }

        public static function checkIfExist($table, $field)
        {
            $db = XenForo_Application::get('db');
            if ($db->fetchRow('SHOW columns FROM `' . $table . '` WHERE Field = ?', $field)) {
                return true;
            }
            else {
                return false;
            }
        }


        public static function addContentType($name, $value, $addon)
        {
            $query =
                    "
                INSERT INTO " . self::CONTENT_TYPE_TABLE . " (
                content_type ,
                addon_id ,
                fields
                )
                VALUES (
                '" . $name . "',
                '" . $addon . "',
                ''
                );
        ";

            $db = XenForo_Application::get('db');
            $db->query($query);
        }
    }