<?php

    class Ragtek_PC_Model_Router extends
        XenForo_Model
    {
        const CACHE_KEY = 'ragtek_pc_navtabs';

        public function getUniqueTabId($pageTitle)
        {
            return 'ragtek_' . $pageTitle;
        }

        public function getNavTabs()
        {
            $query = '
        SELECT
        page.*, node.title, node.node_name
        FROM xf_page as page
        JOIN xf_node AS node  ON (page.node_id = node.node_id)
        where
                page.ragtek_link_in_navbar = 1
                ';

            $links = $this->fetchAllKeyed($query, 'node_id');
            return $links;
        }

        public function rebuildTabsCache()
        {
            $tabs = $this->getNavTabs();

            XenForo_Application::setSimpleCacheData(self::CACHE_KEY, $tabs);
        }

        public function haveSection($pageTitle)
        {
            if ($this->getSection($pageTitle) != false) {
                return true;
            }
        }

        /**
         * @param  $pageTitle
         * @return bool|string (if tab exists)
         */
        public function getSection($pageTitle)
        {
            /** @var $model XenForo_Model_Page */
            $model = $this->getModelFromCache('XenForo_Model_Page');
            $page = $model->getPageByName($pageTitle);


            if ($page['ragtek_link_in_navbar'] == 1) {
                return $this->getUniqueTabId($page['node_name']);
            }
            else
            {
                return false;
            }
        }


        /**
         * @deprecated! we don't need this anymore!
         * @param  $title
         * @return array
         */
        public function getRouteById($title)
        {
            $db = $this->_getDb();
            $query = "
        SELECT 'section' FROM ragtek_alternative_page_routes
        WHERE title = ?
        ";


            return $db->fetchRow($query, $title);
        }

        /**
         * @return XenForo_Model_Node
         */
        protected function _getNodeModel()
        {
            return $this->getModelFromCache('XenForo_Model_Node');
        }

        /**
         *
         * @deprecated use the framework for this
         * @static
         * @param string $type
         * @return
         */
        public function getNodesByType($type = 'Page')
        {
            $nodes = $this->_getNodeModel()->getAllNodes();
            foreach ($nodes AS $node) {
                if ($node['node_type_id'] != $type) {
                    unset($nodes[$node['node_id']]);
                }
            }

            return $nodes;
        }
    }
 
