<?php

    class Ragtek_PC_NewsFeedHandler_Comment extends
        XenForo_NewsFeedHandler_Abstract
    {
        /**
         * Fetches the content required by news feed items.
         * Designed to be overridden by child classes using $model->getContentByIds($contentIds) or similar
         *
         * @param array $contentIds
         * @param XenForo_Model_NewsFeed $model
         * @param array $viewingUser Information about the viewing user (keys: user_id, permission_combination_id, permissions)
         *
         * @return array
         */
        public function getContentByIds(array $contentIds, $model, array $viewingUser)
        {
            $fetch = array(
                'join' => Ragtek_PC_Model_Pagecomment::FETCH_USER |
                          Ragtek_PC_Model_Pagecomment::FETCH_NODE,
                'permissionCombinationId' => $viewingUser['permission_combination_id']
            );

            $comments = $this->_getCommentModel()->getCommentsByIds($contentIds, $fetch);

            return $this->_getCommentModel()->unserializePermissionsInList($comments, 'node_permission_cache');
        }


        protected function _getDefaultTemplateTitle($contentType, $action)
        {

            return 'ragtek_pc_newsfeed_' . $contentType . '_' . $action;
        }

        public function canViewNewsFeedItem(array $item, $content, array $viewingUser)
        {
            return $this->_getCommentModel()->canViewComment($content, $null, $content['permissions'], $viewingUser);
        }

        protected $_commentModel = null;

        /**
         * @return Ragtek_PC_Model_Pagecomment
         */
        protected function _getCommentModel()
        {
            if (!$this->_commentModel) {
                $this->_commentModel = XenForo_Model::create('Ragtek_PC_Model_Pagecomment');
            }
            return $this->_commentModel;
        }
    }
 
