<?php

    class Ragtek_PC_Route_Page extends
        XFCP_Ragtek_PC_Route_Page
    {

        public function match($routePath, Zend_Controller_Request_Http $request, XenForo_Router $router)
        {

            $page = $router->resolveActionWithStringParam($routePath, $request, 'node_name');
            $request->setParam('node_name', $page);

            $action = $router->resolveActionWithStringParam($routePath, $request, 'node_name');
            $action = $router->resolveActionAsPageNumber($action, $request);

            $customActions = array(
                'edit-page', 'save-page', 'changestate'
            );

            if (in_array($action, $customActions)) {
                return $this->_handleCustomRoutes($action, $router);
            }


            /** @var $routerM Ragtek_PC_Model_Router */
            $routerM = XenForo_Model::create('Ragtek_PC_Model_Router');
            $nodeName = $request->get('node_name');

            $section = $routerM->getSection($nodeName);

            if (!$section) {
                $section = 'forums';
            }

            return $router->getRouteMatch('XenForo_ControllerPublic_Page', 'index', $section);
        }

        public function buildLink($originalPrefix, $outputPrefix, $action, $extension, $data, array &$extraParams)
        {

            $postHash = '';

            if ($action == 'changestate') {
                $link = XenForo_Link::buildBasicLinkWithStringParam('pages', $action, $extension, $data, 'node_name');
                return $link;
            }

            if ($action == 'page-permalink' && !empty($extraParams['pagecomment'])) {

                $post = $extraParams['pagecomment'];
                unset($extraParams['pagecomment']);

                if (!empty($post['comment_id']) && isset($post['position'])) {

                    $postHash = '#comment-' . intval($post['comment_id']);
                    $extraParams['page'] = floor($post['position'] / Ragtek_PC_StaticMethods::perPage()) + 1;
                }

                $action = '';

                $action = XenForo_Link::getPageNumberAsAction($action, $extraParams);

                $link = XenForo_Link::buildBasicLinkWithStringParam('pages', $action, $extension, $data, 'node_name') . $postHash;
                return $link;
            }
            else {
                return parent::buildLink($originalPrefix, $outputPrefix, $action, $extension, $data, $extraParams);
            }

        }


        protected function _handleCustomRoutes($action, $router)
        {
            switch ($action) {
                case 'edit-page':
                    return $router->getRouteMatch('Ragtek_PC_ControllerPublic_PageEdit', 'EditPage');
                case 'save-page':
                    return $router->getRouteMatch('Ragtek_PC_ControllerPublic_PageEdit', 'SavePage');
                case 'changestate':
                    return $router->getRouteMatch('Ragtek_PC_ControllerPublic_PageEdit', 'ChangeCommentState');
            }
        }
    }


