<?php

    class Ragtek_PC_StaticMethods
    {
        const CONTENT_TYPE = 'ragtek_pagecomment';

        const ADDON_ID = 'ragtekPC';


        public static function perPage()
        {
            return XenForo_Application::get('options')->ragtek_pc_CommentsPerPage;
        }

        public static function extendView($class, array &$extend)
        {
            if ($class == 'XenForo_ViewPublic_Page_View') {
                $extend[] = 'Ragtek_PC_View_Page';
            }
        }


        public static function extendRouter($class, array &$extend)
        {
            if ($class == 'XenForo_Route_Prefix_Pages') {
                $extend[] = 'Ragtek_PC_Route_Page';
            }
        }


        public static function listener($class, &$extend)
        {
            if ($class == 'XenForo_ControllerPublic_Page') {
                $extend[] = 'Ragtek_PC_ControllerPublic_Page';
            }

            if ($class == 'XenForo_ControllerPublic_Goto') {
                $extend[] = 'Ragtek_PC_ControllerPublic_Goto';
            }

            if ($class == 'XenForo_ControllerAdmin_Page') {
                $extend[] = 'Ragtek_PC_ControllerAdmin_Page';
            }
        }

        public static function dwListener($class, array &$extend)
        {
            if ($class == 'XenForo_DataWriter_Page') {
                $extend[] = 'Ragtek_PC_DW_Page';
            }
        }


        public static function templateHooks($name, &$contents, array $params, XenForo_Template_Abstract $template)
        {
            switch ($name) {
                case 'pagenode_container_article':
                    $contents .= $template->create('ragtek_page_commentcontainer', $template->getParams());
                    break;

                case 'account_alerts_extra':
                    $optName = Ragtek_PC_StaticMethods::CONTENT_TYPE . '_' . 'quote';
                    $params = array_merge($template->getParams(), array(
                                                                       'optName' => $optName
                                                                  ));
                    $contents .= $template->create('ragtek_page_alert_preferences', $params);
                    break;

                case 'search_form_tabs':
                    $params = $template->getParams();

                    $params += array('ragtek_article_content_type' => Ragtek_PC_StaticMethods::CONTENT_TYPE);
                    $contents .= $template->create('ragtek_page_searchtab', $params)->render();
                    break;

                case 'admin_page_edit_extra':
                    $contents .= $template->create('ragtek_pc_pageedit_comments', $template->getParams())->render();

            }
        }

        public static function navbar(array &$extraTabs, $selectedTabId)
        {
            $tabs = XenForo_Application::getSimpleCacheData(Ragtek_PC_Model_Router::CACHE_KEY);

            if ($tabs) {
                $addTabs = array();
                $pageModel = XenForo_Model::create('XenForo_Model_Page');
                /** @var $pagerouterModel Ragtek_PC_Model_Router */
                $pagerouterModel = XenForo_Model::create('Ragtek_PC_Model_Router');

                foreach ($tabs AS $page)
                {
                    if ($pageModel->canViewPage($page)) {
                        $addTabs[$pagerouterModel->getUniqueTabId($page['node_name'])] = array(
                            'title' => $page['title'],
                            'href' => XenForo_Link::buildPublicLink('full:pages', $page)
                        );
                    }
                }
                $extraTabs = array_merge($extraTabs, $addTabs);
            }
        }

        public static function fileHashes(XenForo_ControllerAdmin_Abstract $controller, array &$hashes)
        {
            $fileHashes = Ragtek_PC_Hashes::getHashes();
            $hashes += $fileHashes;
        }
    }